;//////////// LeprechaunTicTacToe v03.11.28 ////////////
;
;	Author: Ymar
;	Mail: ymar@mircscripts.org
;
;//////////// LeprechaunTicTacToe v03.11.28 ////////////

on *:load:if ($version < 5.9) { e LeprechaunTicTacToe requires mIRC v5.9 or greater. Get it at www.mirc.co.uk | e Loading incomplete | .unload -rs $script | halt } | setvar | e LeprechaunTicTacToe $v loaded | about
on *:start:setvar | listen
alias lttt {
  if ($1 == -s) || (!$1) single
  elseif ($1 == -n) && ($2) play $2
  elseif ($1 == -i) && ($2) { if ($3 !isnum) { e Invalid port specification | return } | new Openingconnection $gettok(%lttt.grid,2-,32) | sockopen lttt-opening $2 $iif($3,$3,$gettok(%lttt.portlisten,2,32)) | i $w(Openingconnection) Connecting to $2 $+ : $+ $sock(lttt-opening).port }
  else { e /lttt: Insufficient parameters | e Usage: lttt -sni [Nick|ip (port)] | e -s : Single player game | e -n : Play versus Nick | e -i : Connect to ip (port) }
}
alias lttt.fixip set %lttt.ip $1
alias -l about  {
  var %w = @lttt.about, %draw = drawtext -r %w,%dg = %draw 32000 arial $mv(15,12) | window -hpCfdo +dL %w 0 0 375 120 | drawrect -rf %w 16777215 1 0 0 375 120 | drawtext -r %w 0 arial $mv(30,25) 100 10 Leprechaun TicTacToe
  %dg 100 35 by Ymar_the_Leprechaun | %dg $calc(355 - $width(v $+ $v,arial,$mv(15,12))) 35 v $+ $v | %draw 0 arial $mv(15,12) 100 60 Thanks to gzerod, jos_, Texel & Zmodem for
  %draw 0 arial $mv(15,12) 100 75 beta-testing and coming up with good ideas. 
  %draw 0 arial $mv(15,12) 100 95 You have played $gettok(%lttt.games,1,32) times and won $gettok(%lttt.games,2,32) of them.
  drawrect -r %w 32000 1 0 0 375 120 | drawrect -r %w 32000 1 360 0 15 15 | %draw 32000 marlett 15 360 0 r | set %lttt.n 0 | .timerlttt -m 0 50 about.tri | window -a %w
}
alias -l about.tri {
  if (@lttt.about != $active) { window -c @lttt.about | .timerlttt off | unset %lttt.n %lttt.a.t | return }
  inc %lttt.n 0.034908 | var %m = 40 * $sin($calc(%lttt.n / 3)), %a1 = $calc(%lttt.n + 2.094395), %a2 = $calc(%lttt.n + 4.18879), %n = 40 * $cos($calc(%lttt.n / 3))
  var %c1 = $calc(45 + $sin(%lttt.n) * %n) $calc(60 + $cos(%lttt.n) * %m),%c2 = $calc(45 + $sin(%a1) * %n) $calc(60 + $cos(%a1) * %m), %c3 = $calc(45 + $sin(%a2) * %n) $calc(60 + $cos(%a2) * %m), %c4 = $calc(45 + %m) $calc(60 + %n)
  drawrect -rnf @lttt.about 16777215 1 1 1 90 110 | drawline -nr @lttt.about 32000 1 %c1 %c2 %c3 %c1 %c4 %c2 %c4 %c3 | drawdot @lttt.about
}
alias -l ai if ($isid) return $gettok(%lttt.ai,$$1,32) | else set %lttt.ai $puttok(%lttt.ai,$$2,$1,32)
alias -l ai.init {
  window -hls +d @lttt.ai.calc | clear @lttt.ai.ctable | clear @lttt.ai.calc
  if ($hget(lttt-ai)) hfree lttt-ai
  var %a = $ai(1) - 1
  if ($ai(1) == 1) {
    if ($calc($ai(2) + $ai(3) + $ai(4) + $ai(5)) < 14) %a = $calc($ifmatch % 2 + 1)
    else %a = $iif($calc($ai(2) / $ai(3) / $ai(4) * $ai(5)) > 1,1,2)
  }
  ai 6 %a
  var %f = $scriptdir $+ $gettok(offensive defensive,%a,32) $+ .ai
  if (!$isfile(%f)) { e File missing: %f | halt }
  hmake lttt-ai 50
  hload -b lttt-ai $+(",%f,")
}
alias -l ai.calc {
  var %str = $replace($hget(lttt.TheLeprechaun,$3 $+ $gettok($2 $1 $calc($1 - $2) $calc($1 + $2),$findtok(h v s t,$3,1,32),32)),2,3,1,2,3,1), %n = $iif($3 == v,$2,$1)
  var %s1 = $remove($gettok(%str,$iif($calc(%n - 4) > 0,$ifmatch,1) $+ - $+ $iif($calc(%n - 4) > 0,$calc($ifmatch + 3),$calc(%n - 1)),45),-)
  var %s2 = $remove($gettok(%str,$calc(%n + 1) $+ - $+ $iif($calc(%n + 4) < $numtok(%str,45),$ifmatch,$numtok(%str,45)),45),-)
  var %s3 = %s1 $+ - $+ %s2
  if (*11111* iswm $replace(%s3,-,1)) return 9999
  elseif (*22222* iswm $replace(%s3,-,2)) return 8000
  elseif (*011110* iswm $replace(%s3,-,1)) && (*011110* !iswm %s3) return 7000
  elseif (*022220* iswm $replace(%s3,-,2)) && (*022220* !iswm %s3) return 6000
  var %i = $hget(lttt-ai,%s1) + $hget(lttt-ai,$mirror(%s2))
  return %i
}
alias -l ai.move {
  var %c = @lttt.ai.ctable, %w = @lttt.ai.calc, %res
  if (!$window(%w)) {
    sw lttt-ai MSG Well if that's how you're going to treat me, I won't play you.
    sockclose lttt-ai
    halt
  }
  ai.ctable $1 $2
  while ($line(%c,1)) {
    var %l = $ifmatch, %x = $gettok(%l,1,32), %y = $gettok(%l,2,32), %res
    if ($fline(%w,& & %l,1)) dline %w $ifmatch
    if (!$gettok($hget(lttt.TheLeprechaun,v $+ %x),%y,45)) {
      aline %w $base($calc($ai.calc(%x,%y,h) + $ai.calc(%x,%y,v) + $ai.calc(%x,%y,s) + $ai.calc(%x,%y,t)),10,10,5) $r(a,z) %l
    }
    dline %c 1
  }
  if ($ai(1) > 1) && ($int($gettok($line(%w,$line(%w,0)),1,32)) > 20) {
    var %s = $int($gettok($line(%w,$line(%w,0)),1,32)) / 1.2 , %n = $line(%w,0) 
    while (($line(%w,%n)) && ($int($gettok($line(%w,%n),1,32)) > %s)) {
      dec %n
    }
    %res = $line(%w,$r(%n,$line(%w,0)))
  }
  else %res = $line(%w,$line(%w,0))
  dline %w 1
  sw lttt-ai COORD $gettok(%res,3-,32)
  ai.ctable $gettok(%res,3-,32)
}
alias -l ai.ctable {
  var %x = $1 - 4, %xm = $1 + 4, %yd = $2 - 4, %ym = $2 + 4, %w = @lttt.ai.ctable, %bm = $numtok($hget(lttt.TheLeprechaun,v1),45)
  if (%x < 1) %x = 1
  if (%yd < 1) %yd = 1
  if (%xm > %bm) %xm = %bm
  if (%ym > %bm) %ym = %bm
  if (!$window(%w)) window -hl +d %w
  while (%x < %xm) {
    var %y = %yd
    while (%y < %ym) {
      if (!$fline(%w,%x %y,0)) aline %w %x %y
      inc %y
    }
    inc %x
  }
}
alias -l ai.p return $iif($ai(1) == $1,$style(1)) $2
alias -l c if ($gettok(%lttt.colours,$1,32) isnum 1-16) return $gettok(16777215 0 8323072 37632 255 127 10223772 8323324 65535 64512 9671424 16776960 16515072 16711935 8355711 13816530,$ifmatch,32) | else return $rgb($2)
alias -l cwin {
  if ($dowin($1,$2,$3)) { 
    sockmark $1 NEWGAME | dialog -m lttt.winlose. $+ $1 lttt.winlose | if ($3 == 2) set %lttt.game.winpop. [ $+ [ $lttt.w($gettok($1,2-,46)) ] ] 1 | set %lttt.games $calc($gettok(%lttt.games,1,32) + 1) $iif($3 == 2,$gettok(%lttt.games,2,32),$calc($gettok(%lttt.games,2,32) + 1))
    did -a lttt.winlose. $+ $1 2 $iif($3 == 2,You lost the game.,You won the game!) 
    did $iif($3 == 1,-b,-c) lttt.winlose. $+ $1 3
    did -a lttt.winlose. $+ $1 1 $1 
    if ($1 == lttt.TheLeprechaun) {
      if ($3 == 1) {
        set %lttt.ai.newgame $true 
        if ($ai(1) == 1) ai $calc($ai(6) * 2 + 1) $calc($ai($calc($ai(6) * 2 + 1)) + 1)
      }
      elseif ($ai(1) == 1) ai $calc($ai(6) * 2) $calc($ai($calc($ai(6) * 2)) + 1)
      halt 
    }
  }
}
alias -l d.c did -c $dname 4 $gettok($did(1),$did(3).sel,32)
alias -l dowin {
  if ($pos($hget($1,$2),$mid($str(- $+ $3,5),2),1)) {
    var %s = $ifmatch, %s = $calc(%s - $int($calc(%s / 2))), %win = @TicTacToe- $+ $gettok($1,-1,46), %draw = drawline -r %win $iif($3 == 1,$c(6,text),$c(7,text)) 3, %r = return $true, %w = $gettok(%lttt.grid,1,32)
    unset %lttt.game.tempdraw. [ $+ [ %win ] ] | goto $left($2,1)
    :v | %draw $calc((%w * ($mid($2,2) - 0.5)) + 2) $calc(%w * (%s - 0.5) + 2) $calc((%w * ($mid($2,2) - 0.5)) + 2) $calc(%w * (%s + 3.5) + 2) | %r
    :h | %draw $calc(%w * (%s - 0.5) + 2) $calc(%w * ($mid($2,2) - 0.5) + 2) $calc(%w * (%s + 3.5) + 2) $calc(%w * ($mid($2,2) - 0.5) + 2) | %r
    :s | %draw $calc(%w * (%s - 0.5) + 2) $calc(%w * (%s - $mid($2,2) - 0.5) + 2) $calc(%w * (%s + 3.5) + 2) $calc(%w * (%s - $mid($2,2) + 3.5) + 2) | %r
    :t | %draw $calc(%w * (%s - 0.4)) $calc(%w * ($mid($2,2) - %s - 0.3)) $calc(%w  * (%s + 3.7)) $calc(%w * ($mid($2,2) - %s - 4.4)) | %r
  }
}
alias -l draw {
  if ($w(*) !iswm $1) return
  var %s = $gettok(%lttt.symbols,$iif($2 < 3,$2,$iif($2 == 5,2,1)),32), %n = 0, %w = $gettok(%lttt.grid,1,32) | while (%n < $len(%s)) {
    inc %n 
    if ($mid(%s,%n,1)) {
      drawtext -nr $1 $gettok($c(6,text) $c(7,text) $t(6,text) $c(2,hilight) $t(7,text),$2,32) marlett $calc(%w - 1) $calc(($3 - 1) * %w + 3) $calc(($4 - 1) * %w + 3) $mid(%s,%n,1)
    }
  }
  if ($5) drawdot $1
}
alias -l e echo $colour(info) -at *** $1-
alias -l hrnm {
  if (!$hget($1)) return | hmake $2 $calc($hget($1,0).item / 2)
  var %n = 1 | while ($hget($1,%n).item) { hadd $2 $ifmatch $hget($1,$ifmatch) | inc %n } | hfree $1
}
alias -l i {
  tokenize 32 $1 $replace($2-,,$chr(32)) | var %s = i.scroll $1
  if (!$2) || (!$window($1)) return | if (-* !iswm $2) tokenize 32 $1 -i $2-
  if ($2 == -i) { %s | drawtext -nrc $1 $c(3,shadow) "ms sans serif" 12 6 $calc($window($1).dh - 34) $calc($window($1).dw - 11) 13 $3- }
  elseif ($2 == -a) { %s | drawtext -nrc $1 $c(3,text) "ms sans serif" 12 6 $calc($window($1).dh - 34) $calc($window($1).dw - 11) 12 * $3- }
  elseif ($istok(-m -o,$2,32)) {
    var %x = $calc(12 + $iif($width($me,ms sans serif,12) > $width($gettok($1,5-,160),ms sans serif,12),$ifmatch,$width($gettok($1,5-,160),ms sans serif,12))), %w = $calc($window($1).dw - 11 - %x)
    var %d = drawtext -nrc $1 $c(3,text) "ms sans serif" 12 6 $calc($window($1).dh - 34) $calc($window($1).dw - 11) 13 $iif($2 == -m,$me,$gettok($$1,5-,160)) $+ :, %a = 1
    var %d2 = drawtext -nrc $1 $c(3,text) "ms sans serif" 12 %x $calc($window($1).dh - 34) %w 13
    var %n = 0 | while (%n < $numtok($3-,32)) { 
      inc %n | if ($width(%t $gettok($3-,%n,32),ms sans serif,12) > %w) { %s | if (%a) { %d | var %a = 0 } | %d2 $iif(%t,%t,$gettok($3-,%n,32)) | if (%t) { dec %n | var %t } }
      else var %t = %t $gettok($3-,%n,32)
    }
    if (%t) { %s | if (%a) { %d | var %a = 0 } | %d2 $iif(%t,%t,$gettok($3-,%n,32)) }
  }
  if (!%lttt.refresh) set %lttt.game.lastinf. [ $+ [ $1 ] ] $addtok($gettok(%lttt.game.lastinf. [ $+ [ $1 ] ] ,-4-,1),$2-,1)
  drawdot $1
}
alias -l i.scroll drawcopy -n $1 6 $calc($window($1).dh - 65) $calc($window($1).dw - 11) 48 $1 6 $calc($window($1).dh - 76) | drawrect -nfr $1 $c(1,face) 1 6 $calc($window($1).dh - 31) $calc($window($1).dw - 10) 11
alias -l listen {
  tokenize 32 %lttt.portlisten | if ($1) {
    if ($portfree($2)) { socklisten lttt-listening $2 | e LeprechaunTicTacToe: Listening for game requests at port $2 }
    else { e LeprechaunTicTacToe: Unable to listen for game requests at port $2 (Already in use) | %lttt.portlisten = 0 $2 }
  }
}
alias -l mirror var %n = 1, %t | while ($mid($1,%n,1) != $null) { var %t = $ifmatch $+ %t | inc %n } | return %t
alias -l mark {
  if ($2 == 1) && ($sock(lttt. $+ $gettok($active,5-,160)).status != active) return
  var %win = $w($gettok($1,-1,46)) | if (%lttt.game.tempdraw. [ $+ [ %win ] ] == $3 $4) { draw %win 4 $ifmatch 1 | unset %lttt.game.tempdraw. [ $+ [ %win ] ] } | if (%lttt.game.lastop. [ $+ [ %win ] ] ) draw %win 2 $ifmatch u | unset %lttt.game.lastop. [ $+ [ %win ] ] | draw %win $iif($2 == 2,5,$2) $3 $4 u | if ($2 == 2) set %lttt.game.lastop. [ $+ [ %win ] ] $3 $4 u
  if ($2 == 1) { sw lttt. $+ $gettok($active,5-,160) COORD $3 $4  | sockmark lttt. $+ $gettok($active,5-,160) COORD | i $active You selected: ( $+ $3 $+ , $+ $4 $+ ) }
  hadd $1 v $+ $3 $puttok($hget($1,v $+ $3),$2,$4,45) | cwin $1 v $+ $3 $2 | hadd $1 h $+ $4 $puttok($hget($1,h $+ $4),$2,$3,45) | cwin $1 h $+ $4 $2
  var %l = s $+ $calc($3 - $4) | hadd $1 %l $puttok($hget($1,%l),$2,$3,45) | cwin $1 %l $2 | var %l = t $+ $calc($3 + $4) | hadd $1 %l $puttok($hget($1,%l),$2,$3,45) | cwin $1 %l $2
  inc %lttt.game.count. [ $+ [ %win ] ] |  if (%lttt.game.count. [ $+ [ %win ] ] == $calc($numtok($hget(%hash,h1),45) * $numtok($hget(%hash,v1),45))) {
    i %win Game finished. Tie. | sockmark %hash NEWGAME | dialog -m lttt.winlose. $+ %hash lttt.winlose | did -a lttt.winlose. $+ %hash 2 The game was a tie | did -a lttt.winlose. $+ %hash 1 $1 | halt 
  }
}
alias -l mv return $iif($version < 5.91,$1,$2)
alias -l new {
  var %win = $w($1), %hash = lttt. $+ $1, %wi = $gettok(%lttt.grid,1,32), %w = $calc($2 * %wi + 2), %h = $calc($3 * %wi + 2), %dl = drawline -nr %win | set %lttt.game.count. [ $+ [ %win ] ] 0
  unset %lttt.game.lastop. [ $+ [ %win ] ] | if (!$window(%win)) window -kpfnB $+ $iif(d isin %lttt.desktop,%lttt.desktop) +lftn %win -1 -1 $calc(%w + 4) $calc(%h + 85) $nopath($mircexe) 1 | if (!%lttt.game.say. [ $+ [ %win ] ] ) set %lttt.game.say. [ $+ [ %win ] ] $chr(124)
  else window -f %win $window(%win).x $window(%win).y  $calc(%w + 4) $calc(%h + 85) | drawrect -nfr %win $c(1,face) 1 0 0 $calc(%w + 4) $calc(%h + 85)
  drawrect -nrf %win $c(2,hilight) 1 2 2 %w %h | %dl $c(4,hilight) 1 $calc(%w + 1) 2 $calc(%w + 1) $calc(%h + 1) 2 $calc(%h + 1)
  %dl $c(4,shadow) 1 2 %h 2 2 $calc(%w + 1) 2 | %dl $c(4,frame) 1 3 %h 3 3 $calc(%w + 1) 3 | %dl $c(4,face) 1 3 %h %w %h %w 2
  %dl $c(4,hilight) 1 $calc(%w + 1) $calc(%h + 5) $calc(%w + 1) $calc(%h + 65) 2 $calc(%h + 65)
  %dl $c(4,shadow) 1 2 $calc(%h + 64) 2 $calc(%h + 5) $calc(%w + 1) $calc(%h + 5) | %dl $c(4,frame) 1 3 $calc(%h + 64) 3 $calc(%h + 6) $calc(%w + 1) $calc(%h + 6)
  var %h2 = $window(%win).dh - 1 | drawrect -nrf %win $c(2,hilight) 1 2 $calc(%h2 - 16) $calc(%w - 2) 14
  %dl $c(4,hilight) 1 $calc(%w + 1) $calc(%h2 - 16) $calc(%w + 1) $calc(%h2 - 1) 2 $calc(%h2 - 1)
  %dl $c(4,shadow) 1 2 $calc(%h2 - 2) 2 $calc(%h2 - 16) $calc(%w + 1) $calc(%h2 - 16) | %dl $c(4,frame) 1 3 $calc(%h2 - 2) 3 $calc(%h2 - 15) $calc(%w + 1) $calc(%h2 - 15)
  drawtext -nrc %win $c(3,text) "ms sans serif" 12 6 $calc($window(%win).dh - 16) $calc($window(%win).dw - 11) 12 %lttt.game.say. [ $+ [ %win ] ]
  if (!$hget(%hash)) hmake %hash $int($calc($2 + $3 / 2)) | else var %s = $true
  var %n = 0 | while (%n < $3) { inc %n | %dl $c(5,face) 1 5 $calc(2 + %n * %wi) $calc(%w - 1) $calc(2 + %n * %wi) | if (!%s) hadd %hash h $+ %n $str(0-,$2) }
  var %n = 0 | while (%n < $2) { inc %n | %dl $c(5,face) 1 $calc(2 + %n * %wi) 5 $calc(2 + %n * %wi) $calc(%h - 1) | if (!%s) hadd %hash v $+ %n $str(0-,$3) }
  if (!%s) { var %n = 0 | while (%n < $calc($2 + $3)) { inc %n | hadd %hash t $+ $calc(%n + 1) $str(0-,$iif($3 > $2,$3,$2)) |  hadd %hash s $+ $round($calc(%n - ($3 + $2) / 2)) $str(0-,$iif($3 > $2,$3,$2)) } }
  else {
    var %x = 0 | while (%x < $numtok($hget(%hash,h1),45)) {
      inc %x | var %y = 0 | while (%y < $numtok($hget(%hash,v1),45)) { inc %y | if ($gettok($hget(%hash,v $+ %x),%y,45)) { var %a = $ifmatch | draw %win %a %x %y } } 
    }
    var %n = 1 | set -u0 %lttt.refresh 1 | while ($gettok(%lttt.game.lastinf. [ $+ [ %win ] ] ,%n,1)) { i %win $ifmatch | inc %n }
  }
  drawdot %win | window -a %win
}
alias -l notce {
  if ($asc($gettok($1-,-1,32)) != $right($hash($gettok($1-,1- $+ $calc($numtok($1-,32) - 1),32),16),2)) || ($2 $+ $3 $+ $remove($4,.) $+ $5 !isnum) return
  if ($input(Do you want to play TicTacToe with $1 $+ ? $crlf $crlf $+ Grid: $2 $+ * $+ $3 $crlf,8,LeprechaunTicTacToe)) { new $1 $2 $3 | sockopen lttt. $+ $1 $4 $5 | sockmark lttt. $+ $1 MYTURN }
}
alias -l play {
  if (!$server) { e LeprechaunTicTacToe: Not connected to server | return }
  if ($hget(lttt. $+ $1)) hfree $ifmatch | new $1 $gettok(%lttt.grid,2-,32) | i $w($1) Waiting... | var %p = 130 | while (!$portfree(%p)) { inc %p | if (%p > 500) { i $w($1) Unable to find open port | halt } }
  socklisten tttl. $+ $1 %p | var %t = $gettok(%lttt.grid,2-,32) $iif(%lttt.ip,%lttt.ip,$ip) %p | .notice $1 LeprechaunTicTacToegamerequest: %t $chr($right($hash($me %t,16),2)) | echo $colour(info) -at *** LeprechaunTicTacToe game request sent to $1
}
alias -l pnewgame {
  if ($dialog(lttt.winlose. $+ $1)) dialog -x $ifmatch
  if ($input(Do you want to play another game with $gettok($1,2-,46) $+ ?,8)) && ($sock($1)) {
    sw $1 ACCEPT | var %w = $numtok($hget($1,h1),45), %h = $numtok($hget($1,v1),45) | hfree $1 | new $gettok($1,2-,46) %w %h | sockmark $1 $iif($2 == 2,MYTURN,COORD)
    i $w($gettok($1,2-,46)) $iif($2 == 2,Your,$gettok($1,2-,46) $+ 's) turn
  }
  else { sockclose $1 | i $w($gettok($1,2-,46)) Connection closed }
}
alias -l single {
  if ($hget(lttt.TheLeprechaun)) hfree $ifmatch | new TheLeprechaun $gettok(%lttt.grid,2-,32) | i $w(TheLeprechaun) Waiting... | var %p = 130 | while (!$portfree(%p)) { inc %p | if (%p > 500) { i $w(TheLeprechaun) Unable to find open port | halt } }
  socklisten tttl.TheLeprechaun %p | var %t = $gettok(%lttt.grid,2-,32) $ip %p | sockopen lttt-ai 127.0.0.1 %p | ai.init
}
alias -l setvar sv grid 15 20 20 | sv colours 17 17 17 17 17 3 5 | sv symbols r n | sv games 0 0 | sv ai 1 1 1 1 1 1 | unset %lttt.game.* | sv portlisten 0 175
alias -l sockrequest if ($input(Do you want to play TicTacToe with $4 $+ ? $crlf $crlf $+ Grid: $2 $+ * $+ $3 $crlf,8,LeprechaunTicTacToe)) { sw $1 ACCEPT $me | sockrename $1 lttt. $+ $4 | new $4 $2 $3 | i $w($4) Connected. Your turn. | sockmark lttt. $+ $4 MYTURN } | else sockclose $1
alias -l sv if (!%lttt. [ $+ [ $1 ] ] ) set %lttt. [ $+ [ $1 ] ] $2-
alias -l sw if (($sock($sockname) != $null) || ($sock($1) != $null)) sockwrite -n $1-
alias -l t var %c = $rgb($c($1,$2)), %b = $rgb($c(2,hilight)), %n = 0,%r | while (%n < 3) { inc %n | var %r = $instok(%r,$round($calc(($gettok(%c,%n,44) + $gettok(%b,%n,44)) / 2),0),0,44) } | return $rgb( [ %r ] )
alias -l v return 03.11.28
alias -l w return @TicTacToe- $+ $1
on *:sockopen:lttt-ai:if ($sockerr) { sockclose $sockname | i $w(TheLeprechaun) Connection error }
on *:sockread:lttt-ai: {
  if ($sockerr) { sockclose $sockname | i $w(TheLeprechaun) Connection error | halt } 
  var %t | sockread %t | if (%lttt.ai.newgame) { sw $sockname NEWGAME | unset %lttt.ai.newgame | halt }
  if (COORD * * iswm %t) ai.move $gettok(%t,2-3,32) | elseif (NEWGAME* iswm %t) { sw $sockname ACCEPT | ai.init }
  elseif (ACCEPT* iswm %t) { var %c = $round($calc($numtok($hget(lttt.TheLeprechaun,h1),45) / 2),0) $round($calc($numtok($hget(lttt.TheLeprechaun,v1),45) / 2),0) | sw $sockname COORD %c | ai.init | ai.ctable %c }
}
on *:sockopen:lttt-opening:if ($sockerr) { sockclose $sockname | i $w(OpeningConnection) Connection failed } | else { sw $sockname $gettok(%lttt.grid,2-,32) $me | i $w(Openingconnection) Connected. Getting user authorization. }
on *:sockread:lttt-opening: {
  if ($sockerr) { sockclose $sockname | return } | var %t | sockread %t | tokenize 32 %t 
  if ($1 == ACCEPT) && ($2) && (!$hget(lttt. $+ $2)) { renwin $w(OpeningConnection) $w($2) | hrnm lttt.Openingconnection lttt. $+ $2 | sockrename $sockname lttt. $+ $2 | i $w($2) Connected | sockmark lttt. $+ $2 COORD  }
  elseif ($1 == ERROR) { i $w(Openingconnection) ERROR: $2- | sockclose $sockname }
  elseif ($1 == ACCEPT) { sw $sockname MSG Nickname Error | i $w(Openingconnection) NickName error | sockclose $sockname }
  else { i $w(Openingconnection) Incorrect reply | sockclose $sockname }
}
on *:sockclose:lttt-opening:i $w(Openingconnection) Connection closed
on *:socklisten:lttt-listening:if (!$sockerr) sockaccept tttl. $+ $ticks $+ $r(1000,9999)
on *:socklisten:tttl.*:sockaccept lttt. $+ $gettok($sockname,2-,46) | i $w($gettok($sockname,2,46)) Connected. | sockmark lttt. $+ $gettok($sockname,2-,46) $iif($sockname == tttl.TheLeprechaun,MYTURN,COORD) | sockclose $sockname
on *:sockread:tttl.*:var %t | sockread %t | tokenize 32 %t | if ($1 $+ $2 isnum 1000-) && ($3) { if (!$hget(lttt. $+ $3)) .timer 1 0 sockrequest $sockname $1- | else { sw $sockname ERROR Already playing with $3 | sockclose $sockname } } | else sockclose $sockname
on *:sockread:lttt.*: {
  var %t = 0, %a = window -g1 $w($gettok($sockname,2-,46)) | sockread %t | tokenize 32 %t 
  if ($1 == $sock($sockname).mark) {
    if ($1 == COORD) && ($2 <= $numtok($hget($sockname,h1),45)) && ($3 <= $numtok($hget($sockname,v1),45)) {
      if (!$gettok($hget(%hash,v $+ $2),$3,45)) { i $w($gettok($sockname,2,46)) $gettok($sockname,2-,46) selected: ( $+ $2 $+ , $+ $3 $+ ) | sockmark $sockname MYTURN | mark lttt. $+ $gettok($sockname,2,46) 2 $2 $3 }
      else { i $w($gettok($sockname,2-,46)) $gettok($sockname,2-,46) tried to cheat. Connection Closed. | sockclose $sockname }
    }
    elseif ($1 == NEWGAME) .timer 1 0 pnewgame $sockname $gettok($sock($sockname).mark,$2,32) %win
    elseif ($1 == ACCEPT) {
      var %h = $numtok($hget($sockname,v1),45), %w = $numtok($hget($sockname,h1),45) | hfree $sockname | sockmark $sockname COORD
      new $gettok($sockname,2-,46) %w %h | sockmark $sockname MYTURN | i $w($gettok($sockname,2-,46)) Your turn
    }
    %a
  }
  elseif ($1 == MSG) { if ($2) i $w($gettok($sockname,2-,46)) -o $2- | %a }
  elseif ($1 == ACTION) { if ($2) i $w($gettok($sockname,2-,46)) -a $gettok($sockname,2-,46)) $2- | %a }
  else { i $w($gettok($sockname,2-,46)) $gettok($sockname,2-,46) tried to cheat. Connection Closed. | sockclose $sockname | %a }
}
on *:sockopen:lttt.*:if ($sockerr) { sockclose $sockname | i $w($gettok($sockname,2,46)) Connection error } | else i $w($gettok($sockname,2,46)) Connected. Your turn :)
on *:sockclose:lttt.*:i $w($gettok($sockname,2,46)) $gettok($sockname,2,46) closed connection | if ($dialog(lttt.winlose. $+ $sockname)) did -b $ifmatch 3
#lttt.notice on
on ^*:notice:LeprechaunTicTacToegamerequest*:?:haltdef | if (%lttt.ignore. [ $+ [ $nick ] ] ) || ($sock(lttt. $+ $nick)) halt | if ($window($w($nick))) { window -c $ifmatch | hfree lttt. $+ $nick } | .timer 1 0 notce $nick $remove($2-,$,$chr(124)) $iif($gettok($1-,-1,32) == $,$) | set -u10 %lttt.ignore. [ $+ [ $nick ] ] $true
#lttt.notice end
menu @TicTacToe* {
  sclick: { 
    if ($inrect($mouse.x,$mouse.y,4,4,$calc($window($active).dw - 8),$calc($window($active).dh - 87))) { 
      if ($sock(lttt. $+ $gettok($active,5-,160))) {
        if ($sock(lttt. $+ $gettok($active,5-,160)).mark == MYTURN) {
          var %x = $int($calc(($mouse.x - 4) / $gettok(%lttt.grid,1,32) + 1)), %y = $int($calc(($mouse.y - 4) / $gettok(%lttt.grid,1,32) + 1)), %hash = lttt. $+ $gettok($active,5-,160)
          if (!$gettok($hget(%hash,v $+ %x),%y,45)) mark %hash 1 %x %y
          unset %lttt.game.tempdraw. [ $+ [ $active ] ]
        }
        else i $active -i ERROR: It is not your turn
      }
      else i $active -i ERROR: No connection available
    }
  }
  mouse: {
    if ($inrect($mouse.x,$mouse.y,4,4,$calc($window($active).dw - 8),$calc($window($active).dh - 87))) {
      var %x = $int($calc(($mouse.x - 4) / $gettok(%lttt.grid,1,32) + 1)), %y = $int($calc(($mouse.y - 4) / $gettok(%lttt.grid,1,32) + 1)),
      titlebar $active - ( $+ %x $+ , $+ %y  $+ ) | if (%lttt.game.tempdraw. [ $+ [ $active ] ] != %x %y) draw $active 4 $ifmatch
      if (!$gettok($hget(lttt. $+ $gettok($active,5-,160),v $+ %x),%y,45)) { draw $active 3 %x %y | set %lttt.game.tempdraw. [ $+ [ $active ] ] %x %y }
      drawdot $active 
    }
    else { titlebar $active | if (%lttt.game.tempdraw. [ $+ [ $active ] ] ) { draw $active 4 $ifmatch | drawdot $active | unset %lttt.game.tempdraw. [ $+ [ $active ] ] ) } }
  }
  leave:titlebar $leftwin | if (%lttt.game.tempdraw. [ $+ [ $leftwin ] ] ) { draw $active 4 $ifmatch | drawdot $leftwin | unset %lttt.game.tempdraw. [ $+ [ $leftwin ] ] ) }
  Options:dialog $iif($dialog(lttt.cfg),-v,-m) lttt.cfg lttt.cfg
  $iif(!%lttt.game.winpop. [ $+ [ $active ] ] ,$style(2)) Request rematch:sw lttt. [ $+ [ $gettok($active,5-,160) ] ] NEWGAME | sockmark lttt. [ $+ [ $gettok($active,5-,160) ] ] ACCEPT | unset %lttt.game.winpop. [ $+ [ $active ] ] | i $active Requested rematch
  -
  $iif($active == $w(TheLeprechaun),AI)
  .$ai.p(1,Intermediate):ai 1 1
  .Newbie
  ..$ai.p(2,Defensive):ai 1 2
  ..$ai.p(3,Offensive):ai 1 3 
}
menu @lttt.about {
  mouse:if ($inrect($mouse.x,$mouse.y,360,0,15,15)) { drawtext -r $active 48640 marlett 15 360 0 r | set %lttt.a.t 1 } | elseif (%lttt.a.t) { drawtext -r $active 32000 marlett 15 360 0 r | unset %lttt.a.t }
  leave:if (%lttt.a.t) { drawtext -r $active 32000 marlett 15 360 0 r | unset %lttt.a.t }
  sclick:if ($inrect($mouse.x,$mouse.y,360,0,15,15)) { window -c $active | .timerttt off | unset %lttt.n %lttt.a.t }
}
menu nicklist,query,menubar {
  lttt
  .$iif($menu != menubar && $1 != $me && $1 != $null && (!$sock(lttt. $+ $1)),Play with $1):play $1
  .$iif($menu == menubar && $window($w(TheLeprechaun)) != $w(TheLeprechaun),Single player game):single
  .$iif($menu == menubar,Play with IP):.lttt -i $$input(Enter IP address:,1) $$input(Enter Port:,1)
  .Options:dialog $iif($dialog(lttt.cfg),-v,-m) lttt.cfg lttt.cfg
  .-
  .Unload:if ($input(Are you sure you want to unload Leprechaun TicTacToe?,8))  .unload -rs " $+ $script $+ "
}
on *:active:@lttt.ai.*:window -n $active
on *:close:@TicTacToe*:hfree lttt. $+ $gettok($target,5-,160) | sockclose lttt. $+ $gettok($target,5-,160) | sockclose tttl. $+ $+ $gettok($target,5-,160) | unset %lttt.game* [ $+ [ $target ] ] | if ($target == $w(TheLeprechaun)) { if ($hget(lttt-ai)) hfree lttt-ai | while ($window(@lttt.ai.*,1)) window -c $ifmatch } | elseif ($target == $w(OpeningConnection)) && ($sock(lttt-opening)) sockclose lttt-opening
on *:close:@lttt.about:.timerttt off | unset %lttt.n
on *:keydown:@TicTacToe*:*: {
  var %s = set % $+ lttt.game.say. $+ $active, %t = %lttt.game.say. [ $+ [ $active ] ] ,%t1 = $gettok(%t,1,124), %t2 = $gettok(%t,2,124), %k = $keyval, %| = $chr(124), %c = $keychar
  if (%k == 8) { if (|* !iswm %t) %s $left(%t1,$calc($len(%t1) - 1)) $+ $chr(124) $+ %t2 }
  elseif (%k == 13) {
    if (!$sock(lttt. $+ $gettok($active,5-,160))) i $active ERROR: No connection available
    elseif (%t) { 
      if (/* !iswm %t) { sw lttt. $+ $gettok($active,5-,160)) MSG $remove(%t,$chr(124)) | i $active -m $remove(%t,$chr(124)) | %s $chr(124) } 
      elseif (/me == $gettok(%t,1,160)) { sw lttt. $+ $gettok($active,5-,160)) ACTION $remove($gettok(%t,2-,160),$chr(124)) | i $active -a $me $remove($gettok(%t,2-,160),$chr(124)) | %s $chr(124) } 
      else $remove($remove($gettok(%t,1,160),/) $replace($gettok(%t,2-,160),$chr(160),$chr(32)),$chr(124))
    }
  }
  elseif (%k == 35) %s %t1 $+ %t2 $+ $chr(124) | elseif (%k == 36) %s %| $+ %t1 $+ %t2
  elseif (%k == 37) { if (|* !iswm %t) %s $left(%t1,$calc($len(%t1) - 1)) $+ %| $+ $right(%t1,1) $+ %t2 }
  elseif (%k == 39) { if (*| !iswm %t) { if (%t2) %s %t1 $+ $left(%t2,1) $+ %| $+ $mid(%t2,2) | else %s $left(%t1,1) $+ %| $+ $mid(%t1,2) } }
  elseif (%k == 46) { if (*| !iswm %t) { if (%t2) %s %t1 $+ %| $+ $mid(%t2,2) | else %s %| $+ $mid(%t1,2) } }
  elseif (%k == 86) && ($keychar != v) %s $replace(%t,|,$replace($remove($cb(1),$chr(124)),$chr(32),) $+ |)
  elseif ($asc(%c) isnum 32-) && (%c != |) %s $replace(%t,|,$iif($asc(%c) > 32,%c,) $+ |)
  drawrect -nrf $active $c(2,hilight) 1 6 $calc($window($active).dh - 15) $calc($window($active).dw - 11) 12
  drawtext -nrc $active $c(3,text) "ms sans serif" 12 6 $calc($window($active).dh - 16) $calc($window($active).dw - 11) 13 $iif(%lttt.game.say. [ $+ [ $active ] ] ,$ifmatch,|)
  drawdot $active
}
dialog lttt.winlose {
  title Leprechaun TicTacToe $v
  size -1 -1 110 35
  option dbu
  text "" 1, 5 5 10 10, hide
  text "" 2, 5 5 100 10, Center 
  check "&Suggest a new game?" 3, 5 20 75 10,
  button "&Ok" 4, 85 20 20 10, Cancel
}
on *:dialog:lttt.winlose.*:sclick:4:if ($did(3).state) && ($did(3).enabled) { i $w($gettok($did(1),2,46)) Requesting rematch | sw $did(1) NEWGAME | sockmark $did(1) ACCEPT } 
dialog lttt.cfg {
  title Leprechaun TicTacToe Config $v
  size -1 -1 150 125
  option dbu
  text "" 1, 1 1 1 1, hide
  box "Colours" 2, 2 2 145 22,
  combo 3, 5 10 95 70, Drop,
  combo 4, 102 10 40 150, Drop, 
  box "Grid" 5, 2 27 145 22,
  text "Height:" 6, 7 36 20 8, limit 2
  edit "" 7, 30 35 15 10,
  text "Width:" 8, 50 36 20 8, limit 2
  edit "" 9, 72 35 15 10,
  text "Block size:" 10, 97 36 27 8, limit 2
  edit "" 11, 127 35 15 10,
  box "Symbols" 15, 2 52 145 22
  text "You:" 16, 7 61 20 8
  combo 17, 30 60 40 50, drop
  text "Opponent:" 18, 75 61 25 8
  combo 19, 103 60 40 50, drop
  ;box "Game requests" 21, 2 75 145 32
  box "Game requests" 21, 2 75 70 32
  box "Window options" 26, 77 75 70 32
  check "Listen for notices" 20, 7 84 50 8
  check "Listen at port", 24, 7 94 40 8
  edit "" 25, 50 93 15 10, autohs
  check "Desktop windows" 14, 85 84 55 8, 
  check "Ontop" 23, 85 94 55 8, disable
  button "About" 22, 2 110 35 12
  button "Ok" 12, 72 110 35 12, Ok
  button "Cancel" 13, 112 110 35 12, Cancel
}
on *:dialog:lttt.cfg:*:*: { 
  if ($devent == init) {
    var %-a = did -a $dname, %-c = did -c $dname
    %-a 1 %lttt.colours | didtok $dname 3 32 Background Background(Box) Text Box Grid You Opponent | didtok $dname 4 32 White Black Navy Green Red Brown Purple Orange Yellow Lime Teal Aqua Blue Fuchsia Gray Silver Windows
    didtok $dname 17,19 45 Circle-Circle (Filled)-Cross-Square-Square (Filled) | %-c 17 $findtok(jklm n r cdef g,$gettok(%lttt.symbols,1,32),1,32)
    %-c 19 $findtok(jklm n r cdef g,$gettok(%lttt.symbols,2,32),1,32) | %-c 3 1 | d.c | %-a 11 $gettok(%lttt.grid,1,32) | %-a 7 $gettok(%lttt.grid,2,32) | %-a 9 $gettok(%lttt.grid,3,32)
    if ($gettok(%lttt.portlisten,1,32)) %-c 24 | else did -b $dname 25 | %-a 25 $gettok(%lttt.portlisten,2,32)
    if (d isin %lttt.desktop) { %-c 14 | did -e $dname 23 } | if (o isin %lttt.desktop) %-c 23 | if ($group(#lttt.notice) == on) %-c 20
  }
  elseif ($devent == sclick) {
    if ($did == 3) d.c | elseif ($did == 4) did -ra $dname 1 $puttok($did(1),$did(4).sel,$did(3).sel,32)
    elseif ($did == 12) {       
      set %lttt.desktop $iif($did(14).state,d) $+ $iif($did(23).state,o) | set %lttt.colours $did(1)  | set %lttt.grid $did(11) $did(7) $did(9)
      set %lttt.symbols $gettok(jklm n r cdef g,$did(17).sel,32) $gettok(jklm n r cdef g,$did(19).sel,32) | $iif($did(20).state,.enable,.disable) #lttt.notice
      set %lttt.portlisten $did(24).state $did(25) | if ($sock(lttt-listening)) sockclose $ifmatch | if ($did(24).state) listen
      var %n = 1 | while ($window(@TicTacToe*,%n)) { var %m = $gettok($ifmatch,5-,160),h1) | new %m $numtok($hget(lttt. $+ %m,h1),45) $numtok($hget(lttt. $+ %m,v1),45) | inc %n } 
    }
    elseif ($did == 14) did $iif($did(14).state,-e,-b) $dname 23
    elseif ($did == 22) about
    elseif ($did == 24) did $iif($did(24).state,-e,-b) $dname 25
  }
  elseif ($devent == edit) did $iif($did(7) isnum 10- && $did(9) isnum 10- && $did(11) isnum 11- && $did(25) isnum,-e,-b) $dname 12
}
on *:unload:unset %lttt.* | sockclose lttt.* | sockclose tttl.* | hfree -w lttt.* | e LeprechaunTicTacToe $v unloaded successfully |
